﻿var weddingDate = options.getValue("wedding_date");
var weddingTime = options.getValue("wedding_time");

var countdownActive = true;
var step = -1;
var countdownFormat = "%D%:%H%:%M%:%S%";
var completionMsg = "00:00:00:00";
var timeoutTime;
var dateDiff;
var secs;
var prevDays;
var days;
var tip = "";
var dynamicLink;
var weddingStreetWeddingsLink = "http://www.magnetstreetweddings.com"

var Time = new Array("12:00 AM","1:00 AM","2:00 AM","3:00 AM","4:00 AM","5:00 AM","6:00 AM","7:00 AM","8:00 AM","9:00 AM","10:00 AM","11:00 AM","12:00 PM","1:00 PM","2:00 PM","3:00 PM","4:00 PM","5:00 PM","6:00 PM","7:00 PM","8:00 PM","9:00 PM","10:00 PM","11:00 PM");
var monthArray = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

function stopCountdown(){
  countdownActive = false;
}

function loadCountdown(){
  countdownActive = true;
  step = Math.ceil(step);
  if (step == 0)
    countdownActive = false;
  timeoutTime = (Math.abs(step)-1)*1000 + 957;
  var endDate = new Date(weddingDate);
  endDate.setHours(weddingTime)
  var currentDate = new Date();
  if(step > 0){
    dateDiff = new Date(currentDate - endDate);
  } else{
    dateDiff = new Date(endDate - currentDate);
  }
  secs = Math.floor(dateDiff.valueOf()/1000);
  countDown(secs);
}

function calculateTime(secs, num1, num2, padResult) {
  s = ((Math.floor(secs/num1))%num2).toString();
  if (padResult && s.length < 2)
    s = "0" + s;
  return s;
}

function countDown(seconds) {
  if (seconds < 0) {
    countdown_days.innerText = "0";
    countdown_time.innerText = completionMsg;
    return;
  }
  prevDays = days;
  days = calculateTime(seconds,86400,100000, false);

  if(prevDays != days)
    getTipOfDay();
  
  
  var displayDate;
  
  if(days == 1){
    days_text.innerText = "day";
  } else {
    days_text.innerText = "days";
  }
  
  countdown_days.innerText = days;
  
  displayDate = countdownFormat.replace(/%D%/g, days);
  displayDate = displayDate.replace(/%H%/g, calculateTime(seconds,3600,24, true));
  displayDate = displayDate.replace(/%M%/g, calculateTime(seconds,60,60, true));
  displayDate = displayDate.replace(/%S%/g, calculateTime(seconds,1,60, true));

  countdown_time.innerText = displayDate;
  if (countdownActive)
    setTimeout("countDown(" + (seconds+step) + ")", timeoutTime);
}	

function getWeddingDate() {
  var convertedWedDate;
  var tempDate = new Date(weddingDate);
  var conv_date = tempDate.getDate();  
  var conv_month = monthArray[(tempDate.getMonth())]; 
  var conv_year = tempDate.getFullYear();
  
  wedding_date.innerText = conv_month + " " + conv_date + ", " + conv_year;
}

function getWeddingTime() {
  displayTime = getDisplayTime(weddingTime);
  wedding_time.innerText = displayTime;
}

function getDisplayTime(intTime){
  return  Time[intTime];
}

function onOpen() {
  weddingDate = (options.getValue("wedding_date") == "")? "" : options.getValue("wedding_date");
  weddingTime = (options.getValue("wedding_time") == "")? "" : options.getValue("wedding_time");
  if(weddingDate != "" && weddingDate != null && weddingTime != "" && weddingTime != null){
    stopCountdown();
    setTimeout("loadCountdown()", 1000);
    getWeddingDate();
    //getWeddingTime();
    getTipOfDay();
  } else {
    setTip("");
  }
}

function onOptionChanged() {
  // optionChanged will contain the name of the option which was changed
  var optionChanged = event.propertyName;

  // Update only the appropriate option
  if (optionChanged == "wedding_date")
    weddingDate = options.getValue("wedding_date");
  if (optionChanged == "wedding_time"){
    weddingTime = options.getValue("wedding_time");
  }
  if(weddingDate != "" && weddingTime !=""){
    stopCountdown();
    setTimeout("loadCountdown()", 1000);
    getWeddingDate();
    //getWeddingTime();
    getTipOfDay();
  } else {
    setTip("");
  }
}

function getIntTime(tempTime){
  var returnValue = 0;
  for(var i = 0; i < Time.length; i++){
    if(Time[i] == tempTime)
      returnValue = i;
  }
  return returnValue;
}

function setTip(text){
  var tipsArray = new Array();
  var tipArray = new Array();
  tipsArray = text.split(";");
  if(tipsArray != null && tipsArray != ""){
    var tempTip = tipsArray[days];
    if(tempTip != null && tempTip != ""){
      var tipArray = tempTip.split("|");	
      tip = tipArray[1];
      if(tipArray[2] != null && tipArray[2] != ""){
        dynamicLink = tipArray[2];	  
      } else {
        dynamicLink = weddingStreetWeddingsLink;
      }
    } else {
      tip = "Please update your wedding date and time using the options menu.";
      dynamicLink = weddingStreetWeddingsLink;
    }
  } else {
    tip = "Please update your wedding date and time using the options menu.";
    dynamicLink = weddingStreetWeddingsLink;
  }
  tipOfDay.innerText = tip;
  dynamicLink.href = dynamicLink;
}

var URL = "http://www.magnetstreet.com/free-wedding-tools/weddingtips.txt";
var tipRequest = null;

function getTipOfDay() {
  // Start to download the Google logo
  tipRequest_ = new XMLHttpRequest();
  try {
    tipRequest_.open("GET", URL, true);
  } catch (e) {
    // Catch invalid URLs
    statusLabel.innerText = FAILED;
    tipRequest_ = null;
    return;
  }

  // Set the callback for when the downloading is completed (or failed)
  tipRequest_.onreadystatechange = onTipData;

  // Start the download
  try {
    tipRequest_.send();
  } catch (e) {
    // Catch errors sending the request
    statusLabel.innerText = FAILED;
    tipRequest_ = null;
    return;
  }
}

function onTipData() {
  // Verify that the download completed
  
  if (tipRequest_.readyState != 4)
    return;

  // Verify that the download was successful
  if (tipRequest_.status != 200) {
    statusLabel.innerText = FAILED;
    tipRequest_ = null;
    return;
  }

  // Obtain the stream of image data and set it as the image. If you were
  // just downloading text, you could use .responseText to get the text content
  // of the URL you specified.
  setTip(tipRequest_.responseText);
  //imageControl.visible = true;
  //tatusLabel.visible = false;

  // Destroy the XMLHttpRequest object since it isn't being used anymore
  tipRequest_ = null;
}





